! flag de compilation : -convert big_endian (MPOPM) -byteswapio (meso-grille)
! attention output binaire big_endian
module lecture
  Integer, parameter:: nproc=64
  Integer:: nz,nptot,npart_loc
  Real(4):: ekin, egrav, egint,boxlen,aexp
  Real(4):: omega,omega0,omega_lambda,fk0,h0
  Real(4):: alpha,astart,omega_b,hub
  Integer:: istep
  real(4),dimension(:,:),allocatable::x_loc,v_loc
  character(len=50)::root
end module lecture

module variable
  real(4), dimension(:,:),allocatable :: x,v
end module variable

program read_pm_para
  use variable
  use lecture
  implicit none
  write(*,*) 'Enter root file name for reading (ex.: sucdm_p1_65)'
  read(*,*) root
  call pm_para_lecture()

  deallocate(x,v)
  stop
end program read_pm_para

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine pm_para_lecture()
  use lecture
  use variable
  implicit none

  !-----------------------------------------------
  ! Lecture du fichier particules au format PM_Para
  !-----------------------------------------------
  integer:: sum,k,i,j
  character :: filename*30

  Open(10,file=trim(root)//'.0000',form='unformatted')
  Rewind 10

  ! for sucdm
  Read(10) nz,nptot,boxlen,aexp, &
       &     omega,omega0,omega_lambda, &
       &     omega_b,fk0,h0,hub, &
       &     alpha,astart,istep
  Read(10) ekin,egrav,egint

  close(10)

  Write(*,*) nz,nptot,boxlen,aexp, &
       &     omega,omega0,omega_lambda, &
       &     fk0,h0, &
       &     alpha,astart,istep
  Write(*,*) ekin,egrav,egint
  npart_loc = nptot/nproc
  write(*,*)'There are ',nptot,' DM particles'
  write(*,*)'Reading positions ...'

  write(*,*) 'npart_loc=',npart_loc
  allocate(x(3,nptot),v(3,nptot))

  sum=0
  do k=1,nproc
     allocate(x_loc(3,npart_loc),v_loc(3,npart_loc))
     Write(filename,'(a,".",i4.4)') trim(root),k-1
     write(*,*) filename
     Open(10,file=trim(filename),form='unformatted')
     Rewind 10

     ! for sucdm
     Read(10) nz,nptot,boxlen,aexp, &
          &     omega,omega0,omega_lambda, &
          &     omega_b,fk0,h0,hub, &
          &     alpha,astart,istep
     Read(10) ekin,egrav,egint

     Read(10) ((x_loc(j,i),j=1,3),i=1,npart_loc)
     Read(10) ((v_loc(j,i),j=1,3),i=1,npart_loc)

     close(10)
     sum=sum+npart_loc
     do j=1,npart_loc
        x(1,sum-npart_loc+j)=real(x_loc(1,j),4)
        x(2,sum-npart_loc+j)=real(x_loc(2,j),4)
        x(3,sum-npart_loc+j)=real(x_loc(3,j),4)
        v(1,sum-npart_loc+j)=real(v_loc(1,j),4)
        v(2,sum-npart_loc+j)=real(v_loc(2,j),4)
        v(3,sum-npart_loc+j)=real(v_loc(3,j),4)
     enddo
     deallocate(x_loc,v_loc)
  enddo


end subroutine pm_para_lecture
